<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class FpaResumodro extends \Doctrine\ORM\EntityRepository {
    
    public function retornaResumoDroPorEstruturaMesCompetencia($nrorg, $dtocorrencia, $nrestrutura, $nrtipomoviment){
        
        $params = array('nrorg' => $nrorg, 'dtocorrencia' => $dtocorrencia, 'nrestruturam' => $nrestrutura, 'nrtipomoviment' => $nrtipomoviment);
        $fpa_resumodro = Repositories::FPA_RESUMODRO;
$sql = <<<SQL
    SELECT r FROM $fpa_resumodro r
        WHERE r.nrorg = :nrorg
        AND r.dtocorrencia = :dtocorrencia
        AND r.nrestruturam = :nrestruturam
        AND r.nrtipomoviment = :nrtipomoviment
SQL;
        return $this->getEntityManager()->createQuery($sql)->execute($params);
    }

    public function retornaResumoDroPorEstruturaMesCompetenciaMovimento($nrorg, $dtocorrencia, $nrtipomoviment)
    {
        $params = array('nrorg' => $nrorg, 'dtocorrencia' => $dtocorrencia, 'nrtipomoviment' => $nrtipomoviment);
        $fpa_resumodro = Repositories::FPA_RESUMODRO;
        $sql = <<<SQL
    SELECT r FROM $fpa_resumodro r
        WHERE r.nrorg = :nrorg
        AND r.dtocorrencia = :dtocorrencia
        AND r.nrtipomoviment = :nrtipomoviment
SQL;
        return $this->getEntityManager()->createQuery($sql)->execute($params);
    }

    public function retornaResumoDroPorEstruturaSupMesCompetencia($nrorg, $dtocorrencia, $nrestruturaSup, $nrtipomoviment){
    
        $fpa_resumodro = Repositories::FPA_RESUMODRO;
        $params = array('nrorg' => $nrorg, 'dtocorrencia' => $dtocorrencia, 'nrestruturamsup' => $nrestruturaSup, 'nrtipomoviment' => $nrtipomoviment);
$sql = <<<SQL
    SELECT r FROM $fpa_resumodro r
        WHERE r.nrorg = :nrorg
        AND r.dtocorrencia = :dtocorrencia
        AND r.nrestruturamsup = :nrestruturamsup
        AND r.nrtipomoviment = :nrtipomoviment
SQL;
        return $this->getEntityManager()->createQuery($sql)->execute($params);  
          
    }

    public function retornaResumoDroPorEstruturasMesCompetencia($nrorg, $dtocorrencia, $nrestruturaSup, $nrestrutura, $nrtipomoviment){
    
        $fpa_resumodro = Repositories::FPA_RESUMODRO;
        $params = array('nrorg' => $nrorg, 'dtocorrencia' => $dtocorrencia, 'nrestruturamsup' => $nrestruturaSup, 'nrestruturam' => $nrestrutura, 'nrtipomoviment' => $nrtipomoviment);
$sql = <<<SQL
    SELECT r FROM $fpa_resumodro r
        WHERE r.nrorg = :nrorg
        AND r.dtocorrencia = :dtocorrencia
        AND r.nrestruturamsup = :nrestruturamsup
        AND r.nrestruturam = :nrestruturam
        AND r.nrtipomoviment = :nrtipomoviment
SQL;
        return $this->getEntityManager()->createQuery($sql)->execute($params);  
          
    }

    
}